#include "delay.h"

void delay::ms(uint32_t ms)
{
	ms *= F_CPU / 1000 / STM32_CYCLES_PER_LOOP;

	asm volatile(".syntax unified \n\t"
		     " mov r0, %[ms] \n\t"
		     "1: subs r0, #1 \n\t"
		     " bne 1b \n\t"
		     :
		     : [ms] "r" (ms)
		     : "r0");
}

void delay::ns(uint32_t ns)
{
	ns *= F_CPU / 1000000 / STM32_CYCLES_PER_LOOP;

	asm volatile(".syntax unified \n\t"
		     " mov r0, %[ns] \n\t"
		     "1: subs r0, #1 \n\t"
		     " bne 1b \n\t"
		     :
		     : [ns] "r" (ns)
		     : "r0");
}
